/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
RTC_HandleTypeDef hrtc;

UART_HandleTypeDef huart1;

SRAM_HandleTypeDef hsram1;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_RTC_Init(void);
static void MX_FSMC_Init(void);
static void MX_USART1_UART_Init(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

//enable the EEVBLOG define to your board
#define EEVBLOG 1

#define FMC_REGION ((uint32_t)0x60000000) // Bank1 FMC NOR/PSRAM
#define CommandAccess FMC_REGION
//#define DataAccess (FMC_REGION + 0x20000) // FSMC_A16
//#define DataAccess (FMC_REGION + 0x3FFFE) // FSMC_A17
#ifdef EEVBLOG
#define DataAccess (FMC_REGION + 0x80000) // FSMC_A18
#else
#define DataAccess (FMC_REGION + 0x40000) // FSMC_A17 also
#endif

//lcd command common amoun ILI models
#ifdef EEVBLOG
#define ILI9341_NOP     0x00
#define ILI9341_SWRESET 0x01
#define ILI9341_RDDID   0x04
#define ILI9341_RDDST   0x09

#define ILI9341_SLPIN   0x10
#define ILI9341_SLPOUT  0x11
#define ILI9341_PTLON   0x12
#define ILI9341_NORON   0x13

#define ILI9341_RDMODE  0x0A
#define ILI9341_RDMADCTL  0x0B
#define ILI9341_RDPIXFMT  0x0C
#define ILI9341_RDIMGFMT  0x0A
#define ILI9341_RDSELFDIAG  0x0F

#define ILI9341_INVOFF  0x20
#define ILI9341_INVON   0x21
#define ILI9341_GAMMASET 0x26
#define ILI9341_DISPOFF 0x28
#define ILI9341_DISPON  0x29

#define ILI9341_CASET   0x2A
#define ILI9341_PASET   0x2B
#define ILI9341_RAMWR   0x2C
#define ILI9341_RAMRD   0x2E

#define ILI9341_PTLAR   0x30
#define ILI9341_VSCRDEF 0x33
#define ILI9341_MADCTL  0x36
#define ILI9341_VSCRSADD 0x37
#define ILI9341_PIXFMT  0x3A

#define ILI9341_FRMCTR1 0xB1
#define ILI9341_FRMCTR2 0xB2
#define ILI9341_FRMCTR3 0xB3
#define ILI9341_INVCTR  0xB4
#define ILI9341_DFUNCTR 0xB6

#define ILI9341_PWCTR1  0xC0
#define ILI9341_PWCTR2  0xC1
#define ILI9341_PWCTR3  0xC2
#define ILI9341_PWCTR4  0xC3
#define ILI9341_PWCTR5  0xC4
#define ILI9341_VMCTR1  0xC5
#define ILI9341_VMCTR2  0xC7

#define ILI9341_RDID1   0xDA
#define ILI9341_RDID2   0xDB
#define ILI9341_RDID3   0xDC
#define ILI9341_RDID4   0xDD

#define ILI9341_GMCTRP1 0xE0
#define ILI9341_GMCTRN1 0xE1

#define ILI9341_MADCTL_MY  0x80
#define ILI9341_MADCTL_MX  0x40
#define ILI9341_MADCTL_MV  0x20
#define ILI9341_MADCTL_ML  0x10
#define ILI9341_MADCTL_RGB 0x00
#define ILI9341_MADCTL_BGR 0x08
#define ILI9341_MADCTL_MH  0x04
#else
#define ILI9488_CASET 0x2A
#define ILI9488_PASET 0x2B
#define ILI9488_RAMWR 0x2C
#define ILI9488_RAMRD 0x2E
#define ILI9488_MADCTL 0x36
#define MADCTL_MY  0x80
#define MADCTL_MX  0x40
#define MADCTL_MV  0x20
#define MADCTL_ML  0x10
#define MADCTL_BGR 0x08
#define MADCTL_MH  0x04
#endif



void lcd_cmd(uint8_t command)
{
	*(uint8_t*)CommandAccess = command;
}

void lcd_data(uint8_t data)
{
	*(uint8_t*)DataAccess = data;
}

void lcd_cmd16(uint16_t command)
{
	*(uint8_t*)CommandAccess = command;
}

void lcd_data16(uint16_t data)
{
	*(uint8_t*)DataAccess = data;
}
void lcd_setwindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1)
{
#ifdef EEVBLOG
	  lcd_cmd(ILI9341_CASET);  // Column addr set
#else
	  lcd_cmd(ILI9488_CASET);  // Column addr set
#endif
	  lcd_data(x0 >> 8);
	  lcd_data(x0 & 0xFF); // XSTART
	  lcd_data(x1 >> 8);
	  lcd_data(x1 & 0xFF); // XEND
#ifdef EEVBLOG
	  lcd_cmd(ILI9341_PASET);  // Row addr set
#else
	  lcd_cmd(ILI9488_PASET);  // Row addr set
#endif
	  lcd_data(y0 >> 8);
	  lcd_data(y0);        // YSTART
	  lcd_data(y1 >> 8);
	  lcd_data(y1);        // YEND
#ifdef EEVBLOG
	  lcd_cmd(ILI9341_RAMWR);  // write to RAM
#else
	  lcd_cmd(ILI9488_RAMWR);  // write to RAM
#endif
}
void lcd_fill_col()
{
	uint16_t colour = 0xffff;
	lcd_setwindow(0,0,480,320);
#ifdef EEVBLOG
	lcd_cmd16(ILI9341_RAMWR);
#else
	lcd_cmd16(ILI9488_RAMWR);
#endif
	for (int x=0;x<320;x++)
		for (int y=0;y<480;y++)
		{
			lcd_data16(colour);
			//HAL_Delay(100);
			//lcd_data16(colour);
		}
}
#ifdef EEVBLOG
void lcd_init()
{
	lcd_cmd(0xEF);
	  lcd_data(0x03);
	  lcd_data(0x80);
	  lcd_data(0x02);

	  lcd_cmd(0xCF);
	  lcd_data(0x00);
	  lcd_data(0XC1);
	  lcd_data(0X30);

	  lcd_cmd(0xED);
	  lcd_data(0x64);
	  lcd_data(0x03);
	  lcd_data(0X12);
	  lcd_data(0X81);

	  lcd_cmd(0xE8);
	  lcd_data(0x85);
	  lcd_data(0x00);
	  lcd_data(0x78);

	  lcd_cmd(0xCB);
	  lcd_data(0x39);
	  lcd_data(0x2C);
	  lcd_data(0x00);
	  lcd_data(0x34);
	  lcd_data(0x02);

	  lcd_cmd(0xF7);
	  lcd_data(0x20);

	  lcd_cmd(0xEA);
	  lcd_data(0x00);
	  lcd_data(0x00);

	  lcd_cmd(ILI9341_PWCTR1);    //Power control
	  lcd_data(0x23);   //VRH[5:0]

	  lcd_cmd(ILI9341_PWCTR2);    //Power control
	  lcd_data(0x10);   //SAP[2:0];BT[3:0]

	  lcd_cmd(ILI9341_VMCTR1);    //VCM control
	  lcd_data(0x3e);
	  lcd_data(0x28);

	  lcd_cmd(ILI9341_VMCTR2);    //VCM control2
	  lcd_data(0x86);  //--

	  lcd_cmd(ILI9341_MADCTL);    // Memory Access Control
	  lcd_data(0x48);

	  lcd_cmd(ILI9341_PIXFMT);
	  lcd_data(0x55);

	  lcd_cmd(ILI9341_FRMCTR1);
	  lcd_data(0x00);
	  lcd_data(0x18);

	  lcd_cmd(ILI9341_DFUNCTR);    // Display Function Control
	  lcd_data(0x08);
	  lcd_data(0x82);
	  lcd_data(0x27);

	  lcd_cmd(0xF2);    // 3Gamma Function Disable
	  lcd_data(0x00);

	  lcd_cmd(ILI9341_GAMMASET);    //Gamma curve selected
	  lcd_data(0x01);

	  lcd_cmd(ILI9341_GMCTRP1);    //Set Gamma
	  lcd_data(0x0F);
	  lcd_data(0x31);
	  lcd_data(0x2B);
	  lcd_data(0x0C);
	  lcd_data(0x0E);
	  lcd_data(0x08);
	  lcd_data(0x4E);
	  lcd_data(0xF1);
	  lcd_data(0x37);
	  lcd_data(0x07);
	  lcd_data(0x10);
	  lcd_data(0x03);
	  lcd_data(0x0E);
	  lcd_data(0x09);
	  lcd_data(0x00);

	  lcd_cmd(ILI9341_GMCTRN1);    //Set Gamma
	  lcd_data(0x00);
	  lcd_data(0x0E);
	  lcd_data(0x14);
	  lcd_data(0x03);
	  lcd_data(0x11);
	  lcd_data(0x07);
	  lcd_data(0x31);
	  lcd_data(0xC1);
	  lcd_data(0x48);
	  lcd_data(0x08);
	  lcd_data(0x0F);
	  lcd_data(0x0C);
	  lcd_data(0x31);
	  lcd_data(0x36);
	  lcd_data(0x0F);

	  lcd_cmd(ILI9341_SLPOUT);    //Exit Sleep

	  HAL_Delay(120);

	  lcd_cmd(ILI9341_DISPON);    //Display on
}
#else
void lcd_init()
{
	  HAL_Delay(150);

	  lcd_cmd(0x28); // Display Off
	  lcd_cmd(0x3A); // Pixel read=565, write=565.
	  lcd_data(0x55);
	  lcd_cmd(0xC0); // Power Control 1
	  lcd_data(0x10);
	  lcd_data(0x10);
	  lcd_cmd(0xC1); // Power Control 2
	  lcd_data(0x41);
	  lcd_cmd(0xC5); // VCOM  Control 1
	  lcd_data(0x00);
	  lcd_data(0x22);
	  lcd_data(0x80);
	  lcd_data(0x40);
	  lcd_cmd(0x36); // Memory Access
	  lcd_data(0x68);
	  lcd_cmd(0xB0); // Interface
	  lcd_data(0x00);
	  lcd_cmd(0xB1); // Frame Rate Control [B0 11]
	  lcd_data(0xB0);
	  lcd_data(0x11);
	  lcd_cmd(0xB4); //Inversion Control [02]
	  lcd_data(0x02);
	  lcd_cmd(0xB6); // Display Function Control [02 02 3B] .kbv NL=480
	  lcd_data(0x02);
	  lcd_data(0x02);
	  lcd_data(0x3B);
	  lcd_cmd(0xB7); // Entry Mode
	  lcd_data(0xC6);
	  lcd_cmd(0x3A); // Interlace Pixel Format
	  lcd_data(0x55);
	  lcd_cmd(0xF7); // Adjustment Control 3 [A9 51 2C 82]
	  lcd_data(0xA9);
	  lcd_data(0x51);
	  lcd_data(0x2C);
	  lcd_data(0x82);
	  lcd_cmd(0x11); // Sleep Out

	  HAL_Delay(150);
	  lcd_cmd(0x29); // Display On
}
#endif
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_RTC_Init();
  MX_FSMC_Init();
  MX_USART1_UART_Init();

  /* USER CODE BEGIN 2 */
#ifdef EEVBLOG
  HAL_GPIO_WritePin(GPIOB,GPIO_PIN_1,GPIO_PIN_RESET); //dont know if LCD_BL is low to enable or not use GPIO_PIN_SET if HIGH is required
#else
    HAL_GPIO_WritePin(GPIOA,GPIO_PIN_1,GPIO_PIN_SET);
#endif

 // HAL_Delay(100);
 // HAL_GPIO_WritePin(GPIOA,GPIO_PIN_1,GPIO_PIN_RESET);
  lcd_init();
  HAL_Delay(500);
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	  lcd_fill_col();
	  HAL_Delay(100);
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSE;
  RCC_OscInitStruct.LSEState = RCC_LSE_ON;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 168;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV4;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV2;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_5) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief RTC Initialization Function
  * @param None
  * @retval None
  */
static void MX_RTC_Init(void)
{

  /* USER CODE BEGIN RTC_Init 0 */

  /* USER CODE END RTC_Init 0 */

  /* USER CODE BEGIN RTC_Init 1 */

  /* USER CODE END RTC_Init 1 */
  /** Initialize RTC Only
  */
  hrtc.Instance = RTC;
  hrtc.Init.HourFormat = RTC_HOURFORMAT_24;
  hrtc.Init.AsynchPrediv = 127;
  hrtc.Init.SynchPrediv = 255;
  hrtc.Init.OutPut = RTC_OUTPUT_DISABLE;
  hrtc.Init.OutPutPolarity = RTC_OUTPUT_POLARITY_HIGH;
  hrtc.Init.OutPutType = RTC_OUTPUT_TYPE_OPENDRAIN;
  if (HAL_RTC_Init(&hrtc) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN RTC_Init 2 */

  /* USER CODE END RTC_Init 2 */

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 115200;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_6, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_7, GPIO_PIN_SET);

  /*Configure GPIO pins : PA6 PA7 */
  GPIO_InitStruct.Pin = GPIO_PIN_6|GPIO_PIN_7;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
#ifdef EEVBLOG
  GPIO_InitStruct.Pin = GPIO_PIN_1;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_InitStruct.Pull = GPIO_NOPULL;
    GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
    HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);
#else
  GPIO_InitStruct.Pin = GPIO_PIN_1;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);
#endif
}

/* FSMC initialization function */
static void MX_FSMC_Init(void)
{

  /* USER CODE BEGIN FSMC_Init 0 */

  /* USER CODE END FSMC_Init 0 */

  FSMC_NORSRAM_TimingTypeDef Timing = {0};

  /* USER CODE BEGIN FSMC_Init 1 */

  /* USER CODE END FSMC_Init 1 */

  /** Perform the SRAM1 memory initialization sequence
  */
  hsram1.Instance = FSMC_NORSRAM_DEVICE;
  hsram1.Extended = FSMC_NORSRAM_EXTENDED_DEVICE;
  /* hsram1.Init */
  hsram1.Init.NSBank = FSMC_NORSRAM_BANK1;
  hsram1.Init.DataAddressMux = FSMC_DATA_ADDRESS_MUX_DISABLE;
  hsram1.Init.MemoryType = FSMC_MEMORY_TYPE_SRAM;
  hsram1.Init.MemoryDataWidth = FSMC_NORSRAM_MEM_BUS_WIDTH_16;
  hsram1.Init.BurstAccessMode = FSMC_BURST_ACCESS_MODE_DISABLE;
  hsram1.Init.WaitSignalPolarity = FSMC_WAIT_SIGNAL_POLARITY_LOW;
  hsram1.Init.WrapMode = FSMC_WRAP_MODE_DISABLE;
  hsram1.Init.WaitSignalActive = FSMC_WAIT_TIMING_BEFORE_WS;
  hsram1.Init.WriteOperation = FSMC_WRITE_OPERATION_ENABLE;
  hsram1.Init.WaitSignal = FSMC_WAIT_SIGNAL_DISABLE;
  hsram1.Init.ExtendedMode = FSMC_EXTENDED_MODE_DISABLE;
  hsram1.Init.AsynchronousWait = FSMC_ASYNCHRONOUS_WAIT_DISABLE;
  hsram1.Init.WriteBurst = FSMC_WRITE_BURST_DISABLE;
  hsram1.Init.PageSize = FSMC_PAGE_SIZE_NONE;
  /* Timing */
  Timing.AddressSetupTime = 5;
  Timing.AddressHoldTime = 15;
  Timing.DataSetupTime = 8;
  Timing.BusTurnAroundDuration = 1;
  Timing.CLKDivision = 16;
  Timing.DataLatency = 17;
  Timing.AccessMode = FSMC_ACCESS_MODE_A;
  /* ExtTiming */

  if (HAL_SRAM_Init(&hsram1, &Timing, NULL) != HAL_OK)
  {
    Error_Handler( );
  }

  /* USER CODE BEGIN FSMC_Init 2 */

  /* USER CODE END FSMC_Init 2 */
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  Period elapsed callback in non blocking mode
  * @note   This function is called  when TIM6 interrupt took place, inside
  * HAL_TIM_IRQHandler(). It makes a direct call to HAL_IncTick() to increment
  * a global variable "uwTick" used as application time base.
  * @param  htim : TIM handle
  * @retval None
  */
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
  /* USER CODE BEGIN Callback 0 */

  /* USER CODE END Callback 0 */
  if (htim->Instance == TIM6) {
    HAL_IncTick();
  }
  /* USER CODE BEGIN Callback 1 */

  /* USER CODE END Callback 1 */
}

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
